{    var   : }
{ M, IERR }
Unit DE41R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE40R_p, UTDE12_p;

procedure DE41R(F :Proc_F70; var M :Integer; XN :Real;
                var YN :Array of Real; var DYN :Array of Real;
                XK :Real; var H :Real; var Y :Array of Real;
                var DY :Array of Real; var DELTY :Array of Real;
                var DF :Array of Real; var RFN :Array of Real;
                var RF :Array of Real; var YP :Array of Real;
                var DYP :Array of Real; var IERR :Integer);

implementation

procedure DE41R(F :Proc_F70; var M :Integer; XN :Real;
                var YN :Array of Real; var DYN :Array of Real;
                XK :Real; var H :Real; var Y :Array of Real;
                var DY :Array of Real; var DELTY :Array of Real;
                var DF :Array of Real; var RFN :Array of Real;
                var RF :Array of Real; var YP :Array of Real;
                var DYP :Array of Real; var IERR :Integer);
var
I,JSTART :Integer;
HS,H1,X :Real;
BUL :Boolean;
label
_1,_2,_3,_4,_5;
begin
for I:=1 to M do
 begin
  DY[I-1] := DYN[I-1];
_1:
  Y[I-1] := YN[I-1];
 end;
X := XN;
if ( XN = XK )
 then goto _5;
H := Sign(H,XK-XN);
BUL := False;
JSTART := 0;
_2:
if ( not BUL ) 
 then goto _3;
H := HS;
goto _5;
_3:
H1 := XK-X;
if ( Abs(H1) > Abs(H) )
 then goto _4;
HS := H;
BUL := True;
H := H1;
_4:
DE40R(F,M,JSTART,Y,X,DY,H,DELTY,DF,RFN,RF,YP,DYP,
     IERR);
if ( IERR = 0 ) 
 then goto _2;
UTDE12(IERR,41);
_5:
end;

end.
