Unit DE28RS_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure DE28RS(M :Integer; IORDER :Integer; var FH :Array of Real;
                var DF :Array of Real; var R :Array of Real);

implementation

procedure DE28RS(M :Integer; IORDER :Integer; var FH :Array of Real;
                var DF :Array of Real; var R :Array of Real);
var
I,K,K1,K2 :Integer;
label
_1,_2,_3,_4,_5,_6;
begin
for I:=1 to M do
 begin
  if ( IORDER >= 4 ) 
   then goto _2;
  if ( IORDER = 1 ) 
   then goto _5;
  if ( IORDER <> 2 ) 
   then goto _1;
  DF[(I-1)+1*M] := FH[I-1]-DF[(I-1)+0*M];
  goto _5;
_1:
  R[I-1] := DF[(I-1)+1*M];
  DF[(I-1)+1*M] := FH[I-1]-DF[(I-1)+0*M];
  DF[(I-1)+2*M] := DF[(I-1)+1*M]-R[I-1];
  goto _5;
_2:
  K1 := IORDER-3;
  for K:=1 to K1 do
   begin
    K2 := IORDER-K;
    DF[(I-1)+(K2+0)*M] := DF[(I-1)+(K2-1)*M];
_3:
   end;
  R[I-1] := DF[(I-1)+1*M];
  DF[(I-1)+1*M] := FH[I-1]-DF[(I-1)+0*M];
  DF[(I-1)+2*M] := DF[(I-1)+1*M]-R[I-1];
  for K:=1 to K1 do
   begin
    K2 := K+2;
    DF[(I-1)+(K2+0)*M] := DF[(I-1)+(K2-1)*M]-DF[(I-1)+(K2+0)*M];
_4:
   end;
_5:
  DF[(I-1)+0*M] := FH[I-1];
_6:
 end;
end;

end.
